Pointer = {
    draw = function (self, ac_heading, ptr_heading, view, context)
        rotation = ac_heading - ptr_heading
        parked = helpers_park_pointer(ac_heading, ptr_heading, view.viewable)

        canvas_draw(self.canvas,
            function()
                _rotate(-rotation, view.centre.x, view.centre.y)
                if not parked then
                    self.draw_head(view, context)
                end
                if self.draw_tail and view.viewable == 360 then
                    self.draw_tail(view, context)
                end
            end)
    end,

    visible = function (self, val)
        visible(self.canvas, val)
    end
}

function Pointer:create(canvas_size, head_func, tail_func)
    result = {
        canvas = canvas_add(0, 0, canvas_size, canvas_size),
        draw_head = head_func,
        draw_tail = tail_func,

        draw = Pointer.draw,
        visible = Pointer.visible
    }

    setmetatable(result, self)
    self.__index = self

    return result
end
